<?php
// $Id: pgsql.inc,v 1.19 2009/12/29 01:23:34 boombatower Exp $
/**
 * @file
 * PostgreSQL implementation of review interface.
 *
 * @author Josh Waihi ("fiasco", http://drupal.org/user/188162)
 * @author Jimmy Berry ("boombatower", http://drupal.org/user/214218)
 */

/**
 * PostgreSQL implementation of review interface.
 */
class pifr_client_db_interface_pgsql implements pifr_client_db_interface {

  function get_information() {
    global $db_url;

    $url = parse_url($db_url['pifr_checkout']);
    $db = array();
    $db['name'] = substr(urldecode($url['path']), 1);
    $db['username'] = urldecode($url['user']);
    $db['password'] = urldecode($url['pass']);
    $db['host'] = urldecode($url['host']);
    return $db;
  }

  public function create_database() {
    global $db_url;
    $database = substr(parse_url($db_url['pifr_checkout'], PHP_URL_PATH), 1);
    return (bool) db_query('CREATE DATABASE "%s"', $database);
  }

  public function drop_database() {
    global $db_url;
    $database = substr(parse_url($db_url['pifr_checkout'], PHP_URL_PATH), 1);
    return (bool) db_query('DROP DATABASE "%s"', $database);
  }

  public function set_variable($name, $value) {
    if (db_set_active('pifr_checkout')) {
      $status = db_query("REPLACE INTO {variable} (name, value)
                VALUES ('%s', '%s')", $name, serialize($value));
      $status = $status && db_query('TRUNCATE TABLE cache');
      db_set_active();
      return $status;
    }
    return FALSE;
  }

  public function query($sql) {
    if (db_set_active('pifr_checkout')) {
      $result = @db_query($sql);
      $rows = array();
      while ($row = db_fetch_array($result)) {
        $rows[] = $row;
      }
      db_set_active();
      return $rows;
    }
    return FALSE;
  }

  public function import($file) {
    if ($this->query(file_get_contents($file))) {
      $information = $this->get_information();
      $database = $information['name'];
      $tables = $this->query("SELECT table_name FROM information_schema.tables WHERE (table_schema = '$database' OR table_catalog = '$database')");
      return count($tables);
    }
    return FALSE;
  }
}
