<?php
// $Id: bzr.inc,v 1.7 2009/12/31 21:16:49 boombatower Exp $
/**
 * @file
 * BZR implementation of review interface.
 *
 * @author Jimmy Berry ("boombatower", http://drupal.org/user/214218)
 */

/**
 * BZR implementation of review interface.
 */
class PIFRClientReviewVCS_bzr implements PIFRClientReviewVCS {

  public function checkout($directory, $url, $branch) {
    return pifr_client_review::exec("bzr checkout --lightweight $url/$branch $directory");
  }

  public function apply($patch) {
    return pifr_client_review::exec("patch -p0 -i $patch");
  }

  public function get_changed_files($patch) {
    $contents = file_get_contents($patch);
    preg_match_all('/^[\+-]{3}\s+(.*?)\s/m', $contents, $matches, PREG_SET_ORDER);

    $files = array();
    foreach ($matches as $match) {
      if ($match[1] != '/dev/null') {
        $files[] = $match[1];
      }
    }
    return array_unique($files);
  }

  public function get_display($url, $branch) {
    return $branch;
  }
}
