<?php
// $Id: cvs.inc,v 1.10 2009/12/31 21:16:49 boombatower Exp $
/**
 * @file
 * CVS implementation of review interface.
 *
 * @author Jimmy Berry ("boombatower", http://drupal.org/user/214218)
 */

/**
 * CVS implementation of review interface.
 */
class PIFRClientReviewVCS_cvs implements PIFRClientReviewVCS {

  public function checkout($directory, $url, $branch) {
    if (!preg_match('/(.*?:\/cvs\/.*?)\/(.*?)$/m', $url, $matches)) {
      return FALSE;
    }
    $url = $matches[1];
    $module = $matches[2];

    // If no directory was specified then use the last part of the module.
    if (!$directory) {
      $directory = basename($module);
    }

    return pifr_client_review::exec("cvs -z6 -Q -d$url checkout -d$directory -r $branch $module");
  }

  public function apply($patch) {
    return pifr_client_review::exec("patch -p0 -i $patch");
  }

  public function get_changed_files($patch) {
    $contents = file_get_contents($patch);
    preg_match_all('/^[\+-]{3}\s+(.*?)\s/m', $contents, $matches, PREG_SET_ORDER);

    $files = array();
    foreach ($matches as $match) {
      if ($match[1] != '/dev/null') {
        $files[] = $match[1];
      }
    }
    return array_unique($files);
  }

  public function get_display($url, $branch) {
    return array_pop(explode('/', $url));
  }
}
