<?php
// $Id: pifr_drupal.server.inc,v 1.5 2009/12/19 00:00:22 boombatower Exp $

/**
 * @file
 * Provide Drupal server review implementation.
 *
 * @author Jimmy Berry ("boombatower", http://drupal.org/user/214218)
 */

module_load_include('server.inc', 'pifr_assertion');

/**
 * Drupal server review implementation.
 */
abstract class pifr_server_review_pifr_drupal extends pifr_server_review_pifr_assertion {

  protected $argument_default = array(
    'core' => 7,
    'database' => 'mysql-5.0-isam',
    'modules' => array(),
  );

  /**
   * Modify step information.
   */
  public function __construct() {
    parent::__construct();

    $this->steps['syntax'] = array_merge($this->steps['syntax'], array(
      'title' => 'invalid PHP syntax',
      'active title' => 'detect invalid PHP syntax',
      'description' => 'Check the syntax of your PHP files.',
      'summary' => 'Invalid PHP syntax in @filename',
      'confirmation' => 'pifr_drupal',
    ));
    $this->steps['install'] = array_merge($this->steps['install'], array(
      'title' => 'Drupal installation failure',
      'active title' => 'detect a Drupal installation failure',
      'description' => 'Ensure that you can perform a fresh Drupal install.',
      'summary' => 'Drupal installation failed',
      'confirmation' => 'pifr_drupal',
    ));

    $this->confirmation_default['vcs']['main'] = array(
      'repository' => array(
        'type' => 'cvs',
        'url' => ':pserver:anonymous:anonymous@cvs.drupal.org:/cvs/drupal/drupal',
      ),
      'vcs_identifier' => 'HEAD',
    );
  }
}
